AddDamageType("Time_Bat_Hit",   '<bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBat> %1',    '%2 <bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBat> %1',0.75,1);
AddDamageType("Time_Bat_Dash",   '<bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBatDash> %1',    '%2 <bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBatDash> %1',0.75,1);
AddDamageType("Time_Bat_Passive",   '<bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBatPassive> %1',    '%2 <bitmap:add-ons/Weapon_Ekko_TimeBat/CI_TimeBatPassive> %1',0.75,1);
datablock ParticleData(TimeBatStrikeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "./square";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0 1 1 1";
	colors[1]     = "0 1 1 0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(TimeBatExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 7;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TimeBatStrikeParticle";

   useEmitterColors = true;

   uiName = "";
};

datablock ExplosionData(TimeBatExplosionMajor)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 250;

   particleEmitter = TimeBatExplosionEmitter;
   particleDensity = 500;
   particleRadius = 0.3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(TimeBatExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 250;

   particleEmitter = TimeBatExplosionEmitter;
   particleDensity = 15;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 0";
};
datablock ProjectileData(TimeBatExplosionMajorProj)
{
	directDamage        = 0;
	directDamageType  = $DamageType::Time_Bat_Hit;
	radiusDamageType  = $DamageType::Time_Bat_Hit;
	explosion           = TimeBatExplosionMajor;
	explodeOnPlayerImpact = true;
	explodeOnDeath        = true; 

	muzzleVelocity      = 0;
	velInheritFactor    = 1;

	armingDelay         = 0;
	lifetime            = 1;
	fadeDelay           = 3500;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 1 1";

	uiName = "time explosion";
};
datablock ProjectileData(TimeBatExplosionProj)
{
	directDamage        = 0;
	directDamageType  = $DamageType::Time_Bat_Hit;
	radiusDamageType  = $DamageType::Time_Bat_Hit;
	explosion           = TimeBatExplosionMajorProj;
	explodeOnPlayerImpact = true;
	explodeOnDeath        = true; 

	muzzleVelocity      = 0;
	velInheritFactor    = 1;

	armingDelay         = 0;
	lifetime            = 1;
	fadeDelay           = 3500;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 1 1";

	uiName = "time explosion";
};
datablock ProjectileData(TimeBat_Hit)
{
	directDamage        = 15;
	directDamageType  = $DamageType::Time_Bat_Hit;
	radiusDamageType  = $DamageType::Time_Bat_Hit;
	explosion           = TimeBatExplosion;
	//particleEmitter     = as;

	muzzleVelocity      = 50;
	velInheritFactor    = 1;

	armingDelay         = 0;
	lifetime            = 125;
	fadeDelay           = 70;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 1 1";

	uiName = "";
};
datablock ItemData(TimeBatItem : swordItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./TimeBat.dts";

	 // Basic Item Properties
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Time Bat";
	iconName = "./icon_TimeBat";
	doColorShift = false;
	colorShiftColor = "0 1 0.7 1.000";

	 // Dynamic properties defined by the scripts
	image = TimeBatImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TimeBatImage : swordImage)
{
	// Basic Item properties
	emap = true;
	shapeFile = "./TimeBat.dts";

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = TimeBatItem;
	ammo = " ";
	projectile = TimeBat_Hit;
	projectileType = Projectile;

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = true;

	//casing = " ";
	doColorShift = false;
	colorShiftColor = "0 1 0.7 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.01;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};
datablock ShapeBaseImageData(TimeBatRollImage : swordImage)
{
	// Basic Item properties
	emap = true;
	shapeFile = "./TimeBat.dts";

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = TimeBatItem;
	ammo = " ";
	projectile = TimeBatExplosionProj;
	projectileType = Projectile;

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = true;

	//casing = " ";
	doColorShift = false;
	colorShiftColor = "0 1 1 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.01;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;
	stateAllowImageChange[0]        = false;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = false;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.01;
	stateAllowImageChange[2]        = false;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateScript[2]                  = "CheckDashStrike";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateAllowImageChange[4]        = false;

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};
datablock itemData(ZDriveResonator : swordItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	iconName = "Add-Ons/Weapon_Ekko_TimeBat/icon_ZDrive";
	shapeFile = "base/data/shapes/empty.dts";

	 // Basic Item Properties
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Time Bat";
	doColorShift = false;
	colorShiftColor = "0 1 0.7 1.000";

	 // Dynamic properties defined by the scripts
	image = ZDriveResonatorPhysical;
	canDrop = false;
	uiName = "Zero-Drive";
};
datablock ShapeBaseImageData(ZDriveResonatorImage : swordImage)
{
	shapeFile = "./ZDriveResonator.dts";
	emap = true;
	mountPoint = 2;
	eyeoffset = "0 -1 0";
	offset = "0.05 0 -0.35";
	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";
	doColorShift = true;
};
datablock ShapeBaseImageData(ZDriveResonatorPhysical : swordImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;
	mountPoint = 0;
	eyeoffset = "0 -1 0";
	offset = "-0.1 0 -0.35";
	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";
	doColorShift = true;

	stateName[0]                     = "Activate";
	stateScript[0]                  = "EquipZDrive";
	stateAllowImageChange[0]        = false;
};
datablock staticShapeData(cloneDataShape)
{
	shapeFile = "./CloneFig.dts";
};
function ZDriveResonatorPhysical::EquipZDrive(%this,%player,%slot)
{
	%player.mountImage(ZDriveResonatorImage,2);
	if(%player.timeLoopMade $= "")
	{
		%player.timeLoopMade = "asdf";	
		%player.timeWarpDelay = getSimTime() + $Pref::ZeroDrive::RewindMax * 1000;
		%player.createTimeStream();
	}
}
function TimeBatImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}
function TimeBatImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
function TimeBatRollImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}
function TimeBatRollImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
package TimeBat
{
	function onChangeMax(%old,%new)
	{
		$Pref::ZeroDrive::RewindMax = %new;
		$ZeroDrive::MS = $Pref::ZeroDrive::RewindMax * 1000;
		$ZeroDrive::Ticks = $ZeroDrive::MS / 200;
		%count = clientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%client = clientGroup.getObject(%i);
			if(isObject(%client.player))
			{
				if(%client.player.timeLoopMade !$= "")
				{
					cancel(%client.player.timeLoop);
					%client.player.timeStream.delete();
					%client.player.createTimeStream();
					%client.player.timeWarpDelay = getSimTime() + $Pref::ZeroDrive::RewindMax * 1000;
				}
			}
		}
	}
	function player::createTimeStream(%this)
	{
		if(isObject(%this.timeStream))
			%this.timeStream.delete();
		%this.timeStream = new ScriptObject(){
		};
		%hp = %this.getDamageLevel();
		%pos = %this.getTransform();
		%vel = %this.getVelocity();

		%clone = new staticShape()
		{
			datablock = cloneDataShape;
			position = getWords(%pos,0,2);
		};
		missionCleanup.add( %clone );
		%clone.setTransform(%pos);
		if(%this.client.isEkko)
			%clone.setNodeColor( "ALL", "0 1 1 0.99");
		else
			%clone.setNodeColor("ALL", getWords(%this.client.chestColor,0,2) SPC "0.99");
		%clone.schedule($ZeroDrive::MS,delete);
		%this.timeStream.health[0] = %hp;
		%this.timeStream.position[0] = %pos;
		%this.timeStream.velocity[0] = %vel;
		%this.timeStream.clone[0] = %clone;
		%this.timeLoop = %this.schedule(200,updateTimeStream);
	}
	function player::updateTimeStream(%this)
	{
		if(isObject(%this.timeStream))
		{
			for(%i = $ZeroDrive::Ticks - 1; %i > 0; %i--)
			{
				%this.timeStream.health[%i] = %this.timeStream.health[%i - 1];
				%this.timeStream.position[%i] = %this.timeStream.position[%i - 1];
				%this.timeStream.velocity[%i] = %this.timeStream.velocity[%i - 1];
				if(isObject(%this.timeStream.clone[%i - 1]))
				{
					%color = %i * (1 / $ZeroDrive::Ticks);
					%color = 1 - %color;
					if(%this.client.isEkko)
						%color = "0 1 1" SPC %color;
					else
						%color = getWords(%this.client.chestColor,0,2) SPC %color;
					%this.timeStream.clone[%i] = %this.timeStream.clone[%i - 1];
					%this.timeStream.clone[%i].setNodeColor("ALL",%color);
				}
			}
			%hp = %this.getDamageLevel();
			%pos = %this.getTransform();
			%vel = %this.getVelocity();
			%this.timeStream.health[0] = %hp;
			%this.timeStream.position[0] = %pos;
			%this.timeStream.velocity[0] = %vel;
			%clone = new staticShape()
			{
				datablock = cloneDataShape;
				position = getWords(%pos,0,2);
			};
			missionCleanup.add( %clone );
			%clone.setTransform(%pos);
			if(%this.client.isEkko)
				%clone.setNodeColor( "ALL", "0 1 1 0.99");
			else
				%clone.setNodeColor("ALL", getWords(%this.client.chestColor,0,2) SPC "0.99");
			%clone.schedule($ZeroDrive::MS,delete);
			%this.timeStream.clone[0] = %clone;
			%this.timeLoop = %this.schedule(200,updateTimeStream);
		}
	}
	function player::revertTime(%this)
	{
		if(isObject(%this.timeStream))
		{
			cancel(%this.timeLoop);
			%this.schedule(10010 - $ZeroDrive::MS,createTimeStream);
			%this.timeWarpDelay = getSimTime() + 10 * 1000;
			%this.spawnexplosion(TimeBatExplosionMajorProj,1);
			%this.warpBackLoop(0);
		}
	}
	function player::warpBackLoop(%this,%tick)
	{
		if(%tick < $ZeroDrive::Ticks)
		{
			if(isObject(%veh = %this.getControlObject()))
			{
				%veh.setTransform(%this.timeStream.position[%tick]);
				%veh.setVelocity(%this.timeStream.velocity[%tick]);
			}
			else
			{
				%this.setTransform(%this.timeStream.position[%tick]);
				%this.setVelocity(%this.timeStream.velocity[%tick]);
			}
			%this.setDamageLevel(%this.timeStream.health[%tick]);
			%clone = %this.timeStream.clone[%tick];
			if(isObject(%clone))
				%this.timeStream.clone[%tick].delete();
			%this.spawnexplosion(TimeBatExplosionProj,1);
			%this.schedule(10,warpBackLoop,%tick + 1);
		}
		else
		{
			%this.spawnexplosion(TimeBatExplosionMajorProj,1);
			%this.timeStream.delete();
		}
	}
	function player::applyMovementPercent(%this,%percent)
	{
		%dB = %this.getDataBlock();
		%mFS = %dB.maxForwardSpeed * (%percent / 100);
		%mBS = %dB.maxBackwardSpeed * (%percent / 100);
		%mSS = %dB.maxSideSpeed * (%percent / 100);
		%mCFS = %dB.maxForwardCrouchSpeed * (%percent / 100);
		%mCBS = %dB.maxBackwardCrouchSpeed * (%percent / 100);
		%mCSS = %dB.maxSideCrouchSpeed * (%percent / 100);
		%this.setMaxForwardSpeed(%mFS);
		%this.setMaxBackwardSpeed(%mBS);
		%this.setMaxSideSpeed(%mSS);
		%this.setMaxCrouchForwardSpeed(%mCFS);
		%this.setMaxCrouchBackwardSpeed(%mCBS);
		%this.setMaxCrouchSideSpeed(%CSS);
	}
	function TimeBatRollImage::CheckDashStrike(%this, %player, %slot)
	{
		%eyepoint = %player.getEyePoint(); //Get his eye point
		%eyevector = %player.getEyeVector(); //Get the direction he's looking
		%raycast = containerRaycast(%eyepoint,VectorAdd(%eyepoint,VectorScale(%eyevector,25)),$Typemasks::All,%player);
		%subPlayer = getWord(%raycast,0);
		if(isObject(%subPlayer))
		{
			%player.spawnexplosion(TimeBatExplosionMajorProj,1);
			%player.ekkoLock = false;
			%pos = getWords(%subPlayer.getTransform(),0,2);
			%player.setTransform(vectorAdd(%pos,vectorScale(%eyevector,"-2.5")) SPC getWords(%player.getTransform(),3,5));
			%player.unmountImage(0);
			%player.mountImage(TimeBatImage.getID(),0);
			%objClass = %subPlayer.getClassName();
			%player.setVelocity("0 0 0");
			if(%objClass $= "Player" || %objClass $= "AIPlayer" || %objClass $= "WheeledVehicle" || %objClass $= "FlyingWheeledVehicle")
				%subPlayer.damage(%player, %pos, 25, $DamageType::Time_Bat_Dash);
			%player.spawnexplosion(TimeBatExplosionMajorProj,1);
			%player.dashCooldown = getSimTime() + 3 * 1000;
		}
	}
	function GameConnection::OnDeath(%this, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		cancel(%this.player.timeLoop);
		%this.player.timeStream.delete();
		Parent::OnDeath(%this, %killerPlayer, %killer, %damageType, %damageLoc);
	}
	function player::damage(%player, %sourceObject, %position, %damage, %damageType)
	{
		%strDamage = $DamageType_Array[%damageType];
		if((striPos(%strDamage,"Time_Bat") != -1) && (striPos(%strDamage,"Time_Bat_Passive") == -1) && %player.restackTime < getSimTime())
		{
			if(%player.stackDecay < getSimTime())
				%player.TimeBatStacks = 0;
			%player.TimeBatStacks ++;
			%player.stackDecay = getSimTime() + 4 * 1000;
			%sourcePlayer = %sourceObject.client.player;
			if(%player.TimeBatStacks == 3)
			{
				%player.restackTime = getSimTime() + 5 * 1000;
				%player.stackDecay = getSimTime() + 5 * 1000;
				%player.damage(%sourcePlayer, %position, 20, $DamageType::Time_Bat_Passive);
				%player.spawnexplosion(TimeBatExplosionMajorProj,1);
				%sourcePlayer.applyMovementPercent(180);
				if(isObject(%sourcePlayer.resetMovement))
					cancel(%sourcePlayer.resetMovement);
				%sourcePlayer.resetMovement = %sourcePlayer.schedule(3000,applyMovementPercent,100);

				%player.applyMovementPercent(55);
				if(isObject(%player.resetMovement))
					cancel(%player.resetMovement);
				%player.resetMovement = %player.schedule(3000,applyMovementPercent,100);
			}
		}
		parent::damage(%player, %sourceObject, %position, %damage, %damageType);
	}
	function armor::onTrigger(%this, %player, %slot, %val)
	{
		%client = %player.client;
		if(%slot $= 4)
		{
			if(isObject(%player) && %player.getMountedImage(0).getID() == TimeBatImage.getID() && %player.dashCooldown < getSimTime())
			{
				%player.mountImage(TimeBatRollImage.getID(),0);
				%player.ekkoLock = true;
				%player.setVelocity(VectorAdd(%player.getVelocity(),VectorScale(getWord(%player.getEyeVector(),0) SPC getWord(%player.getEyeVector(),1) SPC 0.35,15)));
			}
		}
		parent::onTrigger(%this, %player, %slot, %val);
	}
	function player::mountImage(%player,%image,%slot,%loaded,%string)
	{
		if(%image.getID() == TimeBatImage.getID() && %player.timeLoopMade $= "")
		{
			%player.timeLoopMade = "asdf";
			%player.timeWarpDelay = getSimTime() + $Pref::ZeroDrive::RewindMax * 1000;
			%player.createTimeStream();
		}
		if(!%player.ekkoLock)
			parent::mountImage(%player,%image,%slot,%loaded,%string);
	}
	function player::unmountImage(%player,%slot)
	{
		if(!%player.ekkoLock)
			parent::unmountImage(%player,%slot);
	}
	function serverCmdUseTool(%client,%slot)
	{
		%player = %client.player;
		if(isObject(%player) && !%player.ekkoLock)
			parent::serverCmdUseTool(%client,%slot);
	}
	function serverCmdLight(%client)
	{
		%this = %client.player;
		if(isObject(%this))
			if((%this.getMountedImage(2).getID() == ZDriveResonatorImage.getID() || %this.getMountedImage(0).getID() == TimeBatImage.getID() || %this.getMountedImage(0).getID() == TimeBatRollImage.getID()) && %this.timeWarpDelay < getSimTime())
				%this.revertTime();
			else
				parent::serverCmdlight(%client);
	}
	function player::ActivateStuff(%this)
	{
		if(isObject(%this.getMountedImage(0)))
			if((%this.getMountedImage(0).getID() == ZDriveResonatorPhysical.getID() || %this.getMountedImage(0).getID() == TimeBatImage.getID() || %this.getMountedImage(0).getID() == TimeBatRollImage.getID()) && %this.timeWarpDelay < getSimTime())
				%this.revertTime();
		if(isObject(%this) && !%this.ekkoLock)
			parent::ActivateStuff(%this);
	}
};
activatePackage(TimeBat);